diff --git a/sys/conf/files b/sys/conf/files
index af12d2dd7548..314e2130340b 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -313,6 +313,7 @@ cheri/cheri_asserts.c			optional cpu_cheri
 cheri/cheri_sysctl.c			optional cpu_cheri
 cheri/cheri_otype.c			optional cpu_cheri
 compat/cheriabi/cheriabi_abort2.c	optional compat_cheriabi
+compat/cheriabi/cheriabi_caprevoke.c	optional compat_cheriabi
 compat/cheriabi/cheriabi_generic.c	optional compat_cheriabi
 compat/cheriabi/cheriabi_mac.c		optional compat_cheriabi
 compat/cheriabi/cheriabi_mmap.c		optional compat_cheriabi
@@ -323,6 +324,7 @@ compat/cheriabi/cheriabi_sysent.c	optional compat_cheriabi
 compat/cheriabi/cheriabi_time.c		optional compat_cheriabi
 compat/cheriabi/cheriabi_uipc.c		optional compat_cheriabi
 compat/cheriabi/cheriabi_vfs.c		optional compat_cheriabi
+vm/vm_caprevoke.c			optional cpu_cheri cheri_caprevoke
 
 # dtrace specific
 cddl/contrib/opensolaris/uts/common/dtrace/dtrace.c	optional dtrace compile-with "${DTRACE_C}" \
diff --git a/sys/conf/files.mips b/sys/conf/files.mips
index 12b5b5740e6d..cf6e2f52c80c 100644
--- a/sys/conf/files.mips
+++ b/sys/conf/files.mips
@@ -58,6 +58,9 @@ mips/mips/trap.c			standard
 mips/mips/uio_machdep.c			standard
 mips/mips/uma_machdep.c			standard
 mips/mips/vm_machdep.c			standard
+mips/mips/vm_machdep_caprevoke.c	optional	cpu_cheri cheri_caprevoke
+mips/mips/vm_machdep_caprevoke_tests.c	optional	cpu_cheri cheri_caprevoke \
+	compile-with "${NORMAL_C} -fomit-frame-pointer"
 
 # misc opt-in bits
 kern/kern_clocksource.c			standard
diff --git a/sys/conf/options.mips b/sys/conf/options.mips
index 131ee47b5985..27204a168ce1 100644
--- a/sys/conf/options.mips
+++ b/sys/conf/options.mips
@@ -143,6 +143,14 @@ CPU_CHERI128			opt_global.h
 #
 CPU_CHERI_NO_SYSCALL_AUTHORIZE opt_global.h
 
+#
+# Capability revocation
+#
+CHERI_CAPREVOKE			opt_global.h
+CHERI_CAPREVOKE_CLOADTAGS	opt_global.h
+CHERI_CAPREVOKE_STATS		opt_global.h
+CHERI_CAPREVOKE_CLEARTAGS	opt_global.h
+
 #
 # Options that control the NetFPGA-10G Embedded CPU Ethernet Core.
 #
diff --git a/sys/kern/capabilities.conf b/sys/kern/capabilities.conf
index 897c64145514..4a788704249a 100644
--- a/sys/kern/capabilities.conf
+++ b/sys/kern/capabilities.conf
@@ -425,6 +425,9 @@ mprotect
 ##
 ## Allow simple VM operations on the current process.
 ##
+caprevoke
+caprevoke_shadow
+caprevoke_entire_shadow_cap
 msync
 munlock
 munlockall
diff --git a/sys/kern/imgact_elf.c b/sys/kern/imgact_elf.c
index 33c440db27f9..c29df14b7204 100644
--- a/sys/kern/imgact_elf.c
+++ b/sys/kern/imgact_elf.c
@@ -2600,7 +2600,7 @@ note_procstat_vmmap(void *arg, struct sbuf *sb, size_t *sizep)
 		sbuf_set_drain(sb, sbuf_count_drain, &size);
 		sbuf_bcat(sb, &structsize, sizeof(structsize));
 		PROC_LOCK(p);
-		kern_proc_vmmap_out(p, sb, -1, vmmap_flags);
+		kern_proc_vmmap_out(p, sb, -1, 0, 0, vmmap_flags);
 		sbuf_finish(sb);
 		sbuf_delete(sb);
 		*sizep = size;
@@ -2608,7 +2608,7 @@ note_procstat_vmmap(void *arg, struct sbuf *sb, size_t *sizep)
 		sbuf_bcat(sb, &structsize, sizeof(structsize));
 		PROC_LOCK(p);
 		kern_proc_vmmap_out(p, sb, *sizep - sizeof(structsize),
-		    vmmap_flags);
+		    0, 0, vmmap_flags);
 	}
 }
 
diff --git a/sys/kern/init_sysent.c b/sys/kern/init_sysent.c
index 794ce9553d04..2b4706469448 100644
--- a/sys/kern/init_sysent.c
+++ b/sys/kern/init_sysent.c
@@ -315,9 +315,9 @@ struct sysent sysent[] = {
 	{ AS(aio_write_args), (sy_call_t *)sys_aio_write, AUE_AIO_WRITE, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 256 = aio_write */
 	{ AS(lio_listio_args), (sy_call_t *)sys_lio_listio, AUE_LIO_LISTIO, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 257 = lio_listio */
 	{ AS(kbounce_args), (sy_call_t *)sys_kbounce, AUE_NULL, NULL, 0, 0, 0, SY_THR_STATIC },	/* 258 = kbounce */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 259 = nosys */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 260 = nosys */
-	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 261 = nosys */
+	{ AS(caprevoke_shadow_args), (sy_call_t *)sys_caprevoke_shadow, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 259 = caprevoke_shadow */
+	{ AS(caprevoke_args), (sy_call_t *)sys_caprevoke, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 260 = caprevoke */
+	{ AS(caprevoke_entire_shadow_cap_args), (sy_call_t *)sys_caprevoke_entire_shadow_cap, AUE_NULL, NULL, 0, 0, SYF_CAPENABLED, SY_THR_STATIC },	/* 261 = caprevoke_entire_shadow_cap */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 262 = nosys */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 263 = nosys */
 	{ 0, (sy_call_t *)nosys, AUE_NULL, NULL, 0, 0, 0, SY_THR_ABSENT },			/* 264 = nosys */
diff --git a/sys/kern/kern_event.c b/sys/kern/kern_event.c
index 008880057cea..8a2b58ac1f64 100644
--- a/sys/kern/kern_event.c
+++ b/sys/kern/kern_event.c
@@ -81,6 +81,14 @@ __FBSDID("$FreeBSD$");
 #include <machine/atomic.h>
 
 #include <vm/uma.h>
+#include <vm/vm_extern.h>
+
+
+#ifdef CHERI_CAPREVOKE
+#include <cheri/cheric.h>
+#include <sys/caprevoke.h>
+#include <vm/vm_caprevoke.h>
+#endif
 
 MALLOC_DEFINE(M_KQUEUE, "kqueue", "memory for kqueue system");
 
@@ -2734,6 +2742,55 @@ kqfd_register(int fd, struct kevent *kev, struct thread *td, int mflag)
 	fdrop(fp, td);
 	return (error);
 }
+
+#ifdef CHERI_CAPREVOKE
+
+int
+kqueue_caprevoke(struct file *fp, const struct vm_caprevoke_cookie *crc)
+{
+	struct kqueue *kq;
+	struct knote *kn;
+	int error, ix;
+	CAPREVOKE_STATS_FOR(crst, crc);
+
+	error = kqueue_acquire(fp, &kq);
+	if (error != 0)
+		return (error);
+
+	KQ_LOCK(kq);
+	for (ix = 0; ix < kq->kq_knlistsize; ix++) {
+		SLIST_FOREACH(kn, &kq->kq_knlist[ix], kn_link) {
+			void * __capability ud = kn->kn_kevent.udata;
+			if (!cheri_gettag(ud))
+				continue;
+	                CAPREVOKE_STATS_BUMP(crst, caps_found);
+			if (vm_caprevoke_test(crc, ud)) {
+				kn->kn_kevent.udata = cheri_revoke(ud);
+	                        CAPREVOKE_STATS_BUMP(crst, caps_cleared);
+			}
+		}
+	}
+	for (ix = 0; ix <= kq->kq_knhashmask; ix++) {
+		SLIST_FOREACH(kn, &kq->kq_knhash[ix], kn_link) {
+			void * __capability ud = kn->kn_kevent.udata;
+			if (!cheri_gettag(ud))
+				continue;
+	                CAPREVOKE_STATS_BUMP(crst, caps_found);
+			if (vm_caprevoke_test(crc, ud)) {
+				kn->kn_kevent.udata = cheri_revoke(ud);
+	                        CAPREVOKE_STATS_BUMP(crst, caps_cleared);
+			}
+		}
+	}
+
+	kqueue_release(kq, 1);
+	KQ_UNLOCK(kq);
+
+	return 0;
+}
+
+#endif
+
 // CHERI CHANGES START
 // {
 //   "updated": 20181203,
diff --git a/sys/kern/kern_exec.c b/sys/kern/kern_exec.c
index d9a025cec725..757736a7d4dd 100644
--- a/sys/kern/kern_exec.c
+++ b/sys/kern/kern_exec.c
@@ -84,6 +84,11 @@ __FBSDID("$FreeBSD$");
 #include <vm/vm_object.h>
 #include <vm/vm_pager.h>
 
+#ifdef CHERI_CAPREVOKE
+#include <cheri/cheric.h>
+#include <vm/vm_caprevoke.h>
+#endif
+
 #ifdef	HWPMC_HOOKS
 #include <sys/pmckern.h>
 #endif
@@ -1073,6 +1078,11 @@ exec_new_vmspace(struct image_params *imgp, struct sysentvec *sv)
 	    cpu_exec_vmspace_reuse(p, map)) {
 		shmexit(vmspace);
 		pmap_remove_pages(vmspace_pmap(vmspace));
+
+#ifdef CHERI_CAPREVOKE
+		map->vm_caprev_sh = NULL;
+#endif
+
 		vm_map_remove(map, vm_map_min(map), vm_map_max(map));
 		/*
 		 * An exec terminates mlockall(MCL_FUTURE), ASLR state
@@ -1143,6 +1153,22 @@ exec_new_vmspace(struct image_params *imgp, struct sysentvec *sv)
 	if (error != KERN_SUCCESS)
 		return (vm_mmap_to_errno(error));
 
+#ifdef CHERI_CAPREVOKE
+	/*
+	 * For CheriABI, create an anonymous, CoW mapping for the revocation
+	 * bitmaps.
+	 *
+	 * XXX This almost surely belongs elsewhere, but I don't immediately
+	 * see a per-sv hook here.
+	 */
+	if (sv->sv_flags & SV_CHERI) {
+		error = vm_map_install_caprevoke_shadow(map);
+
+		if (error != KERN_SUCCESS)
+			return (vm_mmap_to_errno(error));
+	}
+#endif
+
 	/*
 	 * vm_ssize and vm_maxsaddr are somewhat antiquated concepts, but they
 	 * are still used to enforce the stack rlimit on the process stack.
diff --git a/sys/kern/kern_proc.c b/sys/kern/kern_proc.c
index 3b07793bf6f8..d3cf417dad10 100644
--- a/sys/kern/kern_proc.c
+++ b/sys/kern/kern_proc.c
@@ -2651,7 +2651,8 @@ next:;
  * Must be called with the process locked and will return unlocked.
  */
 int
-kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
+kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen,
+	vm_offset_t startaddr, size_t n, int flags)
 {
 	vm_map_entry_t entry, tmp_entry;
 	struct vattr va;
@@ -2666,6 +2667,7 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 	unsigned int last_timestamp;
 	int error;
 	bool super;
+	size_t pathlen, i;
 
 	PROC_LOCK_ASSERT(p, MA_OWNED);
 
@@ -2681,10 +2683,29 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 	error = 0;
 	map = &vm->vm_map;
 	vm_map_lock_read(map);
-	VM_MAP_ENTRY_FOREACH(entry, map) {
+
+	/* XXX I really wish this could be 0, not 1. But...
+	 *
+	 * Someone is too damn smart and sees NULL for the new ptr and
+	 * zorches the new length, causing the kernel to do a full sweep
+	 * at first.  Pass 1 instead of 0 for the first query base.
+	 */
+	if (startaddr <= 1) {
+		entry = vm_map_entry_first(map);
+	} else {
+		boolean_t in = vm_map_lookup_entry(map, startaddr, &entry);
+		if (!in) {
+			entry = vm_map_entry_succ(entry);
+		}
+	}
+
+	for (i = 0; (entry != &map->header) && (n == 0 || i < n);
+	     entry = vm_map_entry_succ(entry)) {
 		if (entry->eflags & MAP_ENTRY_IS_SUB_MAP)
 			continue;
 
+		i++;
+
 		addr = entry->end;
 		bzero(kve, sizeof(*kve));
 		obj = entry->object.vm_object;
@@ -2722,6 +2743,13 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 		if (entry->protection & VM_PROT_EXECUTE)
 			kve->kve_protection |= KVME_PROT_EXEC;
 
+		if (entry->max_protection & VM_PROT_READ)
+			kve->kve_max_protection |= KVME_PROT_READ;
+		if (entry->max_protection & VM_PROT_WRITE)
+			kve->kve_max_protection |= KVME_PROT_WRITE;
+		if (entry->max_protection & VM_PROT_EXECUTE)
+			kve->kve_max_protection |= KVME_PROT_EXEC;
+
 		if (entry->eflags & MAP_ENTRY_COW)
 			kve->kve_flags |= KVME_FLAG_COW;
 		if (entry->eflags & MAP_ENTRY_NEEDS_COPY)
@@ -2746,6 +2774,18 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 				vref(vp);
 			if (lobj != obj)
 				VM_OBJECT_RUNLOCK(lobj);
+#ifdef OBJ_NOSTORETAGS
+			if ((obj->flags & OBJ_NOSTORETAGS) == 0) {
+				kve->kve_protection |= KVME_PROT_WRITECAPS;
+				kve->kve_max_protection |= KVME_PROT_WRITECAPS;
+			}
+#endif
+#ifdef OBJ_NOLOADTAGS
+			if ((obj->flags & OBJ_NOLOADTAGS) == 0) {
+				kve->kve_protection |= KVME_PROT_READCAPS;
+				kve->kve_max_protection |= KVME_PROT_READCAPS;
+			}
+#endif
 
 			kve->kve_ref_count = obj->ref_count;
 			kve->kve_shadow_count = obj->shadow_count;
@@ -2775,18 +2815,37 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 			kve->kve_type = KVME_TYPE_NONE;
 			kve->kve_ref_count = 0;
 			kve->kve_shadow_count = 0;
+
+			/* Anonymous memory is presumed able to have tags */
+			kve->kve_protection |= KVME_PROT_READCAPS
+					       | KVME_PROT_WRITECAPS;
+
+			kve->kve_max_protection |= KVME_PROT_READCAPS
+						   | KVME_PROT_WRITECAPS;
 		}
 
-		strlcpy(kve->kve_path, fullpath, sizeof(kve->kve_path));
+		if ((kve->kve_protection & KVME_PROT_READ) == 0)
+			kve->kve_protection &= ~KVME_PROT_READCAPS;
+		if ((kve->kve_protection & KVME_PROT_WRITE) == 0)
+			kve->kve_protection &= ~KVME_PROT_WRITECAPS;
+		if ((kve->kve_max_protection & KVME_PROT_READ) == 0)
+			kve->kve_max_protection &= ~KVME_PROT_READCAPS;
+		if ((kve->kve_max_protection & KVME_PROT_WRITE) == 0)
+			kve->kve_max_protection &= ~KVME_PROT_WRITECAPS;
+
+		pathlen = strlcpy(kve->kve_path, fullpath, sizeof(kve->kve_path));
 		if (freepath != NULL)
 			free(freepath, M_TEMP);
 
 		/* Pack record size down */
-		if ((flags & KERN_VMMAP_PACK_KINFO) != 0)
+		if ((flags & KERN_VMMAP_PACK_KINFO) != 0) {
+			if (pathlen > sizeof(kve->kve_path))
+				pathlen = sizeof(kve->kve_path);
+
 			kve->kve_structsize =
 			    offsetof(struct kinfo_vmentry, kve_path) +
-			    strlen(kve->kve_path) + 1;
-		else
+			    pathlen + 1;
+		} else
 			kve->kve_structsize = sizeof(*kve);
 		kve->kve_structsize = roundup(kve->kve_structsize,
 		    sizeof(uint64_t));
@@ -2794,25 +2853,29 @@ kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen, int flags)
 		/* Halt filling and truncate rather than exceeding maxlen */
 		if (maxlen != -1 && maxlen < kve->kve_structsize) {
 			error = 0;
-			vm_map_lock_read(map);
-			break;
+			goto out_nolock;
 		} else if (maxlen != -1)
 			maxlen -= kve->kve_structsize;
 
 		if (sbuf_bcat(sb, kve, kve->kve_structsize) != 0)
 			error = ENOMEM;
-		vm_map_lock_read(map);
 		if (error != 0)
-			break;
+			goto out_nolock;
+		vm_map_lock_read(map);
 		if (last_timestamp != map->timestamp) {
 			vm_map_lookup_entry(map, addr - 1, &tmp_entry);
 			entry = tmp_entry;
 		}
 	}
 	vm_map_unlock_read(map);
+out_nolock:
 	vmspace_free(vm);
 	PRELE(p);
 	free(kve, M_TEMP);
+
+	if (i == 0)
+		error = ENOENT;
+
 	return (error);
 }
 
@@ -2822,8 +2885,17 @@ sysctl_kern_proc_vmmap(SYSCTL_HANDLER_ARGS)
 	struct proc *p;
 	struct sbuf sb;
 	int error, error2, *name;
+	vm_offset_t base;
+	size_t n;
 
 	name = (int *)arg1;
+
+	base = (__cheri_addr vm_offset_t)(req->newptr);
+	req->newptr = NULL;
+
+	n = req->newlen;
+	req->newlen = 0;
+
 	sbuf_new_for_sysctl(&sb, NULL, sizeof(struct kinfo_vmentry), req);
 	sbuf_clear_flags(&sb, SBUF_INCLUDENUL);
 	error = pget((pid_t)name[0], PGET_CANDEBUG | PGET_NOTWEXIT, &p);
@@ -2831,7 +2903,8 @@ sysctl_kern_proc_vmmap(SYSCTL_HANDLER_ARGS)
 		sbuf_delete(&sb);
 		return (error);
 	}
-	error = kern_proc_vmmap_out(p, &sb, -1, KERN_VMMAP_PACK_KINFO);
+	error = kern_proc_vmmap_out(p, &sb, -1, base, n,
+		KERN_VMMAP_PACK_KINFO);
 	error2 = sbuf_finish(&sb);
 	sbuf_delete(&sb);
 	return (error != 0 ? error : error2);
@@ -3545,8 +3618,10 @@ static SYSCTL_NODE(_kern_proc, KERN_PROC_OVMMAP, ovmmap, CTLFLAG_RD |
 	CTLFLAG_MPSAFE, sysctl_kern_proc_ovmmap, "Old Process vm map entries");
 #endif
 
-static SYSCTL_NODE(_kern_proc, KERN_PROC_VMMAP, vmmap, CTLFLAG_RD |
-	CTLFLAG_MPSAFE, sysctl_kern_proc_vmmap, "Process vm map entries");
+/* XXXNWF CTLFLAG_RW is a hack to sneak a parameter in! */
+static SYSCTL_NODE(_kern_proc, KERN_PROC_VMMAP, vmmap, CTLFLAG_RW |
+	CTLFLAG_MPSAFE, sysctl_kern_proc_vmmap,
+	"Process vm map entries");
 
 #if defined(STACK) || defined(DDB)
 static SYSCTL_NODE(_kern_proc, KERN_PROC_KSTACK, kstack, CTLFLAG_RD |
diff --git a/sys/kern/kern_sig.c b/sys/kern/kern_sig.c
index b68df88e5f28..ae50c3b3330d 100644
--- a/sys/kern/kern_sig.c
+++ b/sys/kern/kern_sig.c
@@ -99,6 +99,10 @@ __FBSDID("$FreeBSD$");
  */
 #include <cheri/cheri.h>
 #include <cheri/cheric.h>
+#ifdef CHERI_CAPREVOKE
+#include <vm/vm_caprevoke.h>
+#include <sys/caprevoke.h>
+#endif
 #endif
 
 #include <machine/cpu.h>
@@ -1744,6 +1748,24 @@ kern_sigaltstack(struct thread *td, stack_t *ss, stack_t *oss)
 	return (0);
 }
 
+#ifdef CHERI_CAPREVOKE
+void
+sigaltstack_caprevoke(struct thread *td, const struct vm_caprevoke_cookie *crc)
+{
+	CAPREVOKE_STATS_FOR(crst, crc);
+
+	void * __capability sp = td->td_sigstk.ss_sp;
+
+	if (cheri_gettag(sp)) {
+		CAPREVOKE_STATS_BUMP(crst, caps_found);
+		if (vm_caprevoke_test(crc, sp)) {
+			CAPREVOKE_STATS_BUMP(crst, caps_cleared);
+			td->td_sigstk.ss_sp = cheri_revoke(sp);
+		}
+	}
+}
+#endif
+
 struct killpg1_ctx {
 	struct thread *td;
 	ksiginfo_t *ksi;
diff --git a/sys/kern/kern_time.c b/sys/kern/kern_time.c
index 5c1a244287c1..8dee2b0106c4 100644
--- a/sys/kern/kern_time.c
+++ b/sys/kern/kern_time.c
@@ -67,6 +67,12 @@ __FBSDID("$FreeBSD$");
 #include <vm/vm.h>
 #include <vm/vm_extern.h>
 
+#ifdef CHERI_CAPREVOKE
+#include <cheri/cheric.h>
+#include <sys/caprevoke.h>
+#include <vm/vm_caprevoke.h>
+#endif
+
 #define MAX_CLOCKS 	(CLOCK_MONOTONIC+1)
 #define CPUCLOCK_BIT		0x80000000
 #define CPUCLOCK_PROCESS_BIT	0x40000000
@@ -1383,6 +1389,40 @@ kern_ktimer_delete(struct thread *td, int timerid)
 	return (0);
 }
 
+#ifdef CHERI_CAPREVOKE
+
+void
+ktimer_caprevoke(struct proc *p, const struct vm_caprevoke_cookie *crc)
+{
+	int i;
+
+	CAPREVOKE_STATS_FOR(crst, crc);
+
+	if (p->p_itimers == NULL)
+		return;
+
+	PROC_LOCK(p);
+	for (i = 0; i < TIMER_MAX; i++) {
+		struct itimer *it = p->p_itimers->its_timers[i];
+		if (it == NULL)
+			continue;
+
+		void * __capability v = it->it_sigev.sigev_value.sival_ptr;
+
+		if (!cheri_gettag(v))
+			continue;
+
+		CAPREVOKE_STATS_BUMP(crst, caps_found);
+		if (vm_caprevoke_test(crc, v)) {
+			it->it_sigev.sigev_value.sival_ptr = cheri_revoke(v);
+			CAPREVOKE_STATS_BUMP(crst, caps_cleared);
+		}
+	}
+	PROC_UNLOCK(p);
+}
+
+#endif
+
 #ifndef _SYS_SYSPROTO_H_
 struct ktimer_settime_args {
 	int timerid;
diff --git a/sys/kern/makesyscalls.sh b/sys/kern/makesyscalls.sh
index 9f4a442c45a4..9800d7cbe33e 100644
--- a/sys/kern/makesyscalls.sh
+++ b/sys/kern/makesyscalls.sh
@@ -77,6 +77,7 @@ fi
 
 if [ -n "$capenabled" ]; then
 	# do nothing
+	:
 elif [ -r $capabilities_conf ]; then
 	capenabled=`egrep -v '^#|^$' $capabilities_conf`
 	capenabled=`echo $capenabled | sed 's/ /,/g'`
diff --git a/sys/kern/syscalls.c b/sys/kern/syscalls.c
index dc011385d615..b22348f595f8 100644
--- a/sys/kern/syscalls.c
+++ b/sys/kern/syscalls.c
@@ -265,9 +265,9 @@ const char *syscallnames[] = {
 	"aio_write",			/* 256 = aio_write */
 	"lio_listio",			/* 257 = lio_listio */
 	"kbounce",			/* 258 = kbounce */
-	"#259",			/* 259 = nosys */
-	"#260",			/* 260 = nosys */
-	"#261",			/* 261 = nosys */
+	"caprevoke_shadow",			/* 259 = caprevoke_shadow */
+	"caprevoke",			/* 260 = caprevoke */
+	"caprevoke_entire_shadow_cap",			/* 261 = caprevoke_entire_shadow_cap */
 	"#262",			/* 262 = nosys */
 	"#263",			/* 263 = nosys */
 	"#264",			/* 264 = nosys */
diff --git a/sys/kern/syscalls.master b/sys/kern/syscalls.master
index ada2c61212a5..842e30e66bbb 100644
--- a/sys/kern/syscalls.master
+++ b/sys/kern/syscalls.master
@@ -1481,7 +1481,24 @@
 		    int flags
 		);
 	}
-259-271	AUE_NULL	UNIMPL	nosys
+259	AUE_NULL	STD	{
+		int caprevoke_shadow(
+			int flags,
+			_In_ void *arena,
+			_Out_ void *shadow,
+		);
+	}
+260	AUE_NULL	STD	{
+		void *caprevoke(
+		    int flags,
+		    uint64_t start_epoch,
+		    _Out_ struct caprevoke_stats *statout,
+		);
+	}
+	261	AUE_NULL	STD {
+		void *caprevoke_entire_shadow_cap(_Out_ void *shadow);
+	}
+262-271	AUE_NULL	UNIMPL	nosys
 272	AUE_O_GETDENTS	COMPAT11 {
 		int getdents(
 		    int fd,
diff --git a/sys/kern/systrace_args.c b/sys/kern/systrace_args.c
index 61343c0b539c..51f2e9989299 100644
--- a/sys/kern/systrace_args.c
+++ b/sys/kern/systrace_args.c
@@ -1330,6 +1330,31 @@ systrace_args(int sysnum, void *params, uint64_t *uarg, int *n_args)
 		*n_args = 4;
 		break;
 	}
+	/* caprevoke_shadow */
+	case 259: {
+		struct caprevoke_shadow_args *p = params;
+		iarg[0] = p->flags; /* int */
+		uarg[1] = (intptr_t) p->arena; /* void * __capability */
+		uarg[2] = (intptr_t) p->shadow; /* void * __capability */
+		*n_args = 3;
+		break;
+	}
+	/* caprevoke */
+	case 260: {
+		struct caprevoke_args *p = params;
+		iarg[0] = p->flags; /* int */
+		uarg[1] = p->start_epoch; /* uint64_t */
+		uarg[2] = (intptr_t) p->statout; /* struct caprevoke_stats * __capability */
+		*n_args = 3;
+		break;
+	}
+	/* caprevoke_entire_shadow_cap */
+	case 261: {
+		struct caprevoke_entire_shadow_cap_args *p = params;
+		uarg[0] = (intptr_t) p->shadow; /* void * __capability */
+		*n_args = 1;
+		break;
+	}
 	/* lchmod */
 	case 274: {
 		struct lchmod_args *p = params;
@@ -5462,6 +5487,48 @@ systrace_entry_setargdesc(int sysnum, int ndx, char *desc, size_t descsz)
 			break;
 		};
 		break;
+	/* caprevoke_shadow */
+	case 259:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "userland void * __capability";
+			break;
+		case 2:
+			p = "userland void * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* caprevoke */
+	case 260:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		case 1:
+			p = "uint64_t";
+			break;
+		case 2:
+			p = "userland struct caprevoke_stats * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* caprevoke_entire_shadow_cap */
+	case 261:
+		switch(ndx) {
+		case 0:
+			p = "userland void * __capability";
+			break;
+		default:
+			break;
+		};
+		break;
 	/* lchmod */
 	case 274:
 		switch(ndx) {
@@ -9746,6 +9813,21 @@ systrace_return_setargdesc(int sysnum, int ndx, char *desc, size_t descsz)
 		if (ndx == 0 || ndx == 1)
 			p = "int";
 		break;
+	/* caprevoke_shadow */
+	case 259:
+		if (ndx == 0 || ndx == 1)
+			p = "int";
+		break;
+	/* caprevoke */
+	case 260:
+		if (ndx == 0 || ndx == 1)
+			p = "void *";
+		break;
+	/* caprevoke_entire_shadow_cap */
+	case 261:
+		if (ndx == 0 || ndx == 1)
+			p = "void *";
+		break;
 	/* lchmod */
 	case 274:
 		if (ndx == 0 || ndx == 1)
diff --git a/sys/kern/uipc_shm.c b/sys/kern/uipc_shm.c
index 223ae1ce93dc..753290b96d19 100644
--- a/sys/kern/uipc_shm.c
+++ b/sys/kern/uipc_shm.c
@@ -735,6 +735,10 @@ shm_remove(char *path, Fnv32_t fnv, struct ucred *ucred)
 	return (ENOENT);
 }
 
+#if __has_feature(capabilities)
+#define SHM_ANON_N	1
+#endif
+
 int
 kern_shm_open2(struct thread *td, const char * __capability userpath,
     int flags, mode_t mode, int shmflags, struct filecaps *fcaps,
@@ -756,6 +760,11 @@ kern_shm_open2(struct thread *td, const char * __capability userpath,
 	if ((shmflags & SHM_ALLOW_SEALING) != 0)
 		initial_seals &= ~F_SEAL_SEAL;
 
+#if __has_feature(capabilities)
+	if ((__cheri_addr uintptr_t) userpath == SHM_ANON_N)
+		userpath = SHM_ANON;
+#endif
+
 #ifdef CAPABILITY_MODE
 	/*
 	 * shm_open(2) is only allowed for anonymous objects.
diff --git a/sys/kern/vfs_aio.c b/sys/kern/vfs_aio.c
index 574d17c0b3bf..b65d7b3849df 100644
--- a/sys/kern/vfs_aio.c
+++ b/sys/kern/vfs_aio.c
@@ -76,10 +76,16 @@ __FBSDID("$FreeBSD$");
 #include <vm/uma.h>
 #include <sys/aio.h>
 
+#include <cheri/cheric.h>
 #ifdef COMPAT_CHERIABI
 #include <compat/cheriabi/cheriabi_util.h>
 #endif
 
+#ifdef CHERI_CAPREVOKE
+#include <sys/caprevoke.h>
+#include <vm/vm_caprevoke.h>
+#endif
+
 /*
  * Counter for allocating reference ids to new jobs.  Wrapped to 1 on
  * overflow. (XXX will be removed soon.)
@@ -2671,6 +2677,67 @@ filt_lio(struct knote *kn, long hint)
 	return (lj->lioj_flags & LIOJ_KEVENT_POSTED);
 }
 
+#ifdef CHERI_CAPREVOKE
+
+void
+aio_caprevoke(struct proc *p, const struct vm_caprevoke_cookie *crc)
+{
+	struct kaioinfo *ki;
+	struct kaiocb *job, *jobn;
+
+	/*
+	 * XXX Does not yet count caps into stats
+	 */
+
+	ki = p->p_aioinfo;
+	if (ki == NULL)
+		return;
+
+	AIO_LOCK(ki);
+
+restart:
+	/* Visit all pending jobs. */
+	TAILQ_FOREACH_SAFE(job, &ki->kaio_jobqueue, plist, jobn) {
+		void * __capability uc =
+			job->uaiocb.aio_sigevent.sigev_value.sival_ptr;
+
+		/* Zorch user pointers being revoked.
+		 *
+		 * The analog in userland (i.e. job->ujob's
+		 * aio_sigevent.sigev_value.sival_ptr) we assume will be
+		 * scrubbed by userland.
+		 */
+		if (vm_caprevoke_test(crc, uc)) {
+			job->uaiocb.aio_sigevent.sigev_value.sival_ptr =
+				cheri_revoke(uc);
+		}
+
+		/* Cancel and finish jobs whose userland metadata
+		 * structure is being revoked, so that all writes take
+		 * place before we return to userland.  Same if the
+		 * buffer itself is in the region being revoked or
+		 * the mysterious "kernelinfo" capability.
+		 */
+		if (   vm_caprevoke_test(crc, job->ujob)
+		    || vm_caprevoke_test(crc,
+					 __DEQUALIFY_CAP(void * __capability,
+					 job->uaiocb.aio_buf))
+		    || vm_caprevoke_test(crc,
+					 job->uaiocb._aiocb_private.kernelinfo)
+		   ) {
+			aio_cancel_job(p, ki, job);
+			ki->kaio_flags |= KAIO_WAKEUP;
+			msleep(&p->p_aioinfo, AIO_MTX(ki), PRIBIO,
+				"aioprn", hz);
+			goto restart;
+		}
+	}
+
+	AIO_UNLOCK(ki);
+}
+
+#endif
+
 #ifdef COMPAT_FREEBSD32
 #include <sys/mount.h>
 #include <sys/socket.h>
diff --git a/sys/mips/cheri/cheriabi_machdep.c b/sys/mips/cheri/cheriabi_machdep.c
index 180daa5910ad..723d56a43c03 100644
--- a/sys/mips/cheri/cheriabi_machdep.c
+++ b/sys/mips/cheri/cheriabi_machdep.c
@@ -596,8 +596,7 @@ cheriabi_sendsig(sig_t catcher, ksiginfo_t *ksi, sigset_t *mask)
 		/* fill siginfo structure */
 		sf.sf_si.si_signo = sig;
 		sf.sf_si.si_code = ksi->ksi_code;
-		sf.sf_si.si_value.sival_int =
-		    ksi->ksi_info.si_value.sival_int;
+		sf.sf_si.si_value.sival_ptr = ksi->ksi_info.si_value.sival_ptr;
 		/*
 		 * Write out badvaddr, but don't create a valid capability
 		 * since that might allow privilege amplification.
diff --git a/sys/mips/conf/std.BENCHMARK b/sys/mips/conf/std.BENCHMARK
index 4184b039b115..2caae39fc172 100644
--- a/sys/mips/conf/std.BENCHMARK
+++ b/sys/mips/conf/std.BENCHMARK
@@ -5,3 +5,5 @@ nooptions	INVARIANTS
 nooptions	INVARIANTS_SUPPORT
 nooptions	KTRACE
 nooptions	WITNESS
+
+nooptions	CHERI_CAPREVOKE_STATS
diff --git a/sys/mips/conf/std.CHERI b/sys/mips/conf/std.CHERI
index 6874ba22cd5e..dfdbf4ecb981 100644
--- a/sys/mips/conf/std.CHERI
+++ b/sys/mips/conf/std.CHERI
@@ -11,4 +11,8 @@ options 	COMPAT_CHERIABI
 options 	COMPAT_FREEBSD64
 #options 	CHERI_IMPLICIT_USER_DDC
 
+options	CHERI_CAPREVOKE
+options	CHERI_CAPREVOKE_CLOADTAGS
+options	CHERI_CAPREVOKE_STATS
+
 options 	TMPFS
diff --git a/sys/mips/include/cherireg.h b/sys/mips/include/cherireg.h
index 68ec76c8e52e..907cb152df2f 100644
--- a/sys/mips/include/cherireg.h
+++ b/sys/mips/include/cherireg.h
@@ -165,6 +165,22 @@
 	CHERI_PERM_SEAL | CHERI_PERM_CCALL | CHERI_PERM_UNSEAL |	\
 	CHERI_PERM_SYSTEM_REGS | CHERI_PERM_SET_CID)
 
+/*
+ * Hardware defines a kind of tripartite taxonomy: memory, type, and CID.
+ * They're all squished together in the permission bits, so define masks
+ * that give us a kind of "kind" for capabilities.  A capability may belong
+ * to zero, one, or more than one of these.
+ */
+
+#define CHERI_PERMS_HWALL_MEMORY                                        \
+	(CHERI_PERM_EXECUTE | CHERI_PERM_LOAD | CHERI_PERM_LOAD_CAP |   \
+		CHERI_PERM_STORE | CHERI_PERM_STORE_CAP |               \
+		CHERI_PERM_STORE_LOCAL_CAP | CHERI_PERM_CCALL)
+
+#define CHERI_PERMS_HWALL_OTYPE	(CHERI_PERM_SEAL | CHERI_PERM_UNSEAL)
+
+// TODO #define CHERI_PERMS_HWALL_CID	(CHERI_PERM_SETCID)
+
 /*
  * Root "object-type" capability for the kernel.  This can be used neither as
  * a data nor code capability.
@@ -247,7 +263,7 @@
 /*
  * When performing a userspace-to-userspace CCall, capability flow-control
  * checks normally prevent local capabilities from being delegated.  This can
- * be disabled on call (but not return) by using an object type with the 22nd
+ * be disabled on call (but not return) by using an object type with the 16th
  * bit set -- combined with a suitable selector on the CCall instruction to
  * ensure that this behaviour is intended.
  */
diff --git a/sys/mips/include/pmap.h b/sys/mips/include/pmap.h
index 336d1725153d..1aec9c46ba82 100644
--- a/sys/mips/include/pmap.h
+++ b/sys/mips/include/pmap.h
@@ -181,6 +181,9 @@ void *pmap_kenter_temporary(vm_paddr_t pa, int i);
 void pmap_kenter_temporary_free(vm_paddr_t pa);
 void pmap_flush_pvcache(vm_page_t m);
 int pmap_emulate_modified(pmap_t pmap, vm_offset_t va);
+#ifdef CPU_CHERI
+int pmap_emulate_capdirty(pmap_t pmap, vm_offset_t va);
+#endif
 void pmap_page_set_memattr(vm_page_t, vm_memattr_t);
 int pmap_change_attr(vm_offset_t, vm_size_t, vm_memattr_t);
 
diff --git a/sys/mips/include/pte.h b/sys/mips/include/pte.h
index 51f51ee3758e..c670e50c55cf 100644
--- a/sys/mips/include/pte.h
+++ b/sys/mips/include/pte.h
@@ -105,7 +105,7 @@ typedef uint64_t pd_entry_t;
 #define	TLBLO_SWBITS_CLEAR_SHIFT	(11)	/* XXXSS: Was 9. */
 #define	TLBLO_PFN_MASK		0x3FFFFFC0ULL
 #define	TLB_1M_SUPERPAGE_SHIFT	(PDRSHIFT)
-#define	TLBLO_SWBITS_MASK	((pt_entry_t)0x7F << TLBLO_SWBITS_SHIFT)
+#define	TLBLO_SWBITS_MASK	((pt_entry_t)0xFF << TLBLO_SWBITS_SHIFT)
 #else
 #define	TLBLO_SWBITS_SHIFT	(29)
 #define	TLBLO_SWBITS_CLEAR_SHIFT	(3)
@@ -194,10 +194,10 @@ typedef uint64_t pd_entry_t;
  *
  * Upper bits of a 64 bit PTE:
  *
- *   63-62   61-60  59   58 -- 56    55   54   53
- *   ---------------------------------------------
- *  |  RG  |      | SV | PG SZ IDX | MN | W  | RO |
- *   ---------------------------------------------
+ *   63-62   61  60    59   58 -- 56    55   54   53
+ *   ------------------------------------------------
+ *  |  RG  |   | CRO | SV | PG SZ IDX | MN | W  | RO |
+ *   ------------------------------------------------
  *
  * VM flags managed in software:
  *
@@ -226,6 +226,9 @@ typedef uint64_t pd_entry_t;
  *
  *  W:  Wired.  ???
  *
+ *  CRO: CHERI-only.  Capability read only.  Never clear PTE_SC on this
+ *       entry, and fail attempts to store capabilities to it.
+ *
  *  RO: Read only.  Never set PTE_D on this page, and don't
  *      listen to requests to write to it.
  *
@@ -244,6 +247,7 @@ typedef uint64_t pd_entry_t;
 #define	PTE_PS_16M		((pt_entry_t)0x30 << TLBLO_SWBITS_SHIFT)
 #define	PTE_PS_64M		((pt_entry_t)0x38 << TLBLO_SWBITS_SHIFT)
 #define	PTE_PS_IDX_MASK		((pt_entry_t)0x38 << TLBLO_SWBITS_SHIFT)
+#define	PTE_CRO			(((pt_entry_t)0x80) << TLBLO_SWBITS_SHIFT)
 #endif
 
 #ifdef CPU_CHERI
